module Day6 (
  findEnd,
  findStart,
  isUnique,
  day6
) where

findMarker :: Int -> String -> Maybe Int
findMarker windowSize = findMarker' 0 ""
  where
  findMarker' :: Int -> String -> String -> Maybe Int
  findMarker' offset window  []
    | isUnique window && length window == windowSize = Just offset
    | otherwise = Nothing
  findMarker' offset window (c:cs)
    | length window < windowSize = findMarker' (offset + 1) (c:window) cs
    | not (isUnique window) = findMarker' (offset + 1) (c:init window) cs
    | isUnique window = Just offset
    | otherwise = Nothing

findStart :: String -> Maybe Int
findStart = findMarker 14 

findEnd :: String -> Maybe Int
findEnd = findMarker 4

isUnique :: (Eq a) => [a] -> Bool
isUnique [] = True
isUnique (c:cs) = c `notElem` cs && isUnique cs

day6 :: IO ()
day6 = do
   input <- readFile "ressources/day06-input"
   putStrLn "Day6"
   let offset = findEnd input
   putStrLn ("Found end marker at " ++ show offset)
   let startOffset = findStart input
   putStrLn ("Found start marker at " ++ show startOffset)
